<?php

function get_line_with_exact_match($file_name, $str) {
    $lines = file($file_name);
    foreach ($lines as $lineNumber => $line) {
        $newline = explode(':', $line);
        if (strcmp($newline[0], $str) == 0) {
            return $line;
        }
    }
    return "";
}

function get_line_with_exact_match_xsplit($file_name, $str) {
    $lines = file($file_name);
    foreach ($lines as $lineNumber => $line) {
        if (strcmp(trim($line), $str) == 0) {
            return $line;
        }
    }
    return "";
}

function get_disabled_array_from_file_xsplit($file_name, $dom) {
        $lines = file($file_name);
        $newlines = array();
        foreach ($lines as $line) {
                if(strcmp($line, $dom) == 0) {
                        continue;
                }
                array_push($newlines, trim($line));
        }
        array_push($newlines, $dom);
        return $newlines;
}

function get_enabled_array_from_file_xsplit($file_name, $dom) {
        $lines = file($file_name);
        $newlines = array();
        foreach ($lines as $line) {
                if(strcmp(trim($line), trim($dom)) == 0) {
                        continue;
                }
                array_push($newlines, trim($line));
        }
        return $newlines;
}



include("/usr/local/cpanel/php/cpanel.php");


$cpanel = &new CPANEL();

$res = $cpanel->api1('Branding', 'include', array('stdheader.html') );
print $res['cpanelresult']['data']['result'];

$user=array($_SERVER['REMOTE_USER']);

$doms_list = array();

$doms1 = $cpanel->api2("DomainLookup","getbasedomains", $user);

for ($i = 0; $i < sizeof($doms1["cpanelresult"]["data"]) ; $i++) {
	array_push($doms_list, $doms1["cpanelresult"]["data"][$i]["domain"]);
}

$doms2 = $cpanel->api2("SubDomain", "listsubdomains", $user);
for ($i = 0; $i < sizeof($doms2["cpanelresult"]["data"]) ; $i++) {
	array_push($doms_list, $doms2["cpanelresult"]["data"][$i]["domain"]);
}

$dom_count = sizeof($doms_list);

$varnish_home = $_SERVER['HOME'] . "/varnish";
$varnish_go = "$varnish_home/process.go";
$varnish_disabled = "$varnish_home/disable_domains.txt";
$varnish_dynamic_ttl = "$varnish_home/dynamic_ttl.txt";
$varnish_static_ttl = "$varnish_home/static_ttl.txt";

if(isset($_POST) && sizeof($_POST) > 0) {
	$final_array = array();
	foreach ($_POST as $key => $item) {   
		if (strlen(stristr($item, "Disabled")) > 0) {
			$final_array = get_disabled_array_from_file_xsplit($varnish_disabled, str_replace("_", ".", $key));
			break;
		}
		else if (strlen(stristr($item, "submit")) > 0) {
			continue;
		}
		else {
			$final_array = get_enabled_array_from_file_xsplit($varnish_disabled, str_replace("_", ".", $key));
			break;
		}
	}
	if (!is_dir($varnish_home)) { mkdir($varnish_home);}

        $disabled = fopen($varnish_disabled, "w+");
        if ($disabled) {
                foreach($final_array as $entry) {
                        if (strlen($entry) > 0) {
                                fwrite($disabled, trim($entry) . "\n");
                        }
                }
        }
        fclose($disabled);

	$hh = fopen($varnish_go, "w+");
	if ($hh) {
		fwrite($hh, "go");
	}
	fclose($hh);
}

?>

<?php include("UNIXyVarnish.menu.html"); ?>

<div class="body-content">
<center><h1>Disable Varnish Caching</h1></center>
</div>

<center>
<table border="1" style="background-color:white;border:1px dotted black;width:80%;border-collapse:collapse; padding-left: 30px;">
<tr style="background-color:orange;color:white;">
<th style="padding:3px;">Domain</th><th style="padding:3px;">Caching Status</th><th style="padding:3px;">Toggle Caching Status</th><th style="padding:3px;">Change</th>
</tr>
<?

for ($i = 0; $i < $dom_count; $i++) {

$dom = $doms_list[$i];

if ( substr($dom, 0, 5) === "mail." || substr($dom, 0, 4) === "ftp." || substr($dom, 0, 2) === "*.") {
	continue;
}

if (strlen(get_line_with_exact_match_xsplit($varnish_disabled, $dom)) > 0) {
        $disabled = "<font color=\"Red\">Disabled</front>";
        $disabled_checked="CHECKED";
        $server_default="";
}
else if (strlen(get_line_with_exact_match($varnish_dynamic_ttl, $dom)) > 0 || strlen(get_line_with_exact_match($varnish_static_ttl, $dom)) > 0) {
        $disabled = "<font color=\"blue\">User Settings</color>";
        $disabled_checked="";
        $server_default="CHECKED";
} else {
        $disabled = "<font color=\"green\">Server Default</font>";
        $disabled_checked="";
        $server_default="CHECKED";
}


echo sprintf("<form method=\"post\" action=\"%s\">", $_SERVER['SCRIPT_NAME']);

print("<tr>");
print("<td style=\"padding:3px;\"><b><a target=\"_blank\" href=\"http://" . $dom . "\">" . $dom . "</a></b></td><td style=\"padding:3px;\">" . $disabled . "</td> <td style=\"padding:3px;\"><input type=\"radio\" name=\"" . $dom . "\" value=\"disabled\" " . $disabled_checked . " /> Disabled <input type=\"radio\" name=\"" . $dom . "\" value=\"default\" " . $server_default. " /> Enabled</td><td style=\"padding: 4px;\"><input type=\"submit\" name=\"Change\" /></td>");
print("</tr>");
echo "</form>";
}

?>
</table>
<br />
</center>
<center>Changes made do NOT take effect immediately. Check with support on run frequency.</center>
<br /><br />
<?php


$h = fopen($varnish_disabled, "r");
if($h) {
	$out = fread($h, filesize($varnish_disabled));
	fclose($h);
}
?>
<?php
$res = $cpanel->api1('Branding', 'include', array('stdfooter.html') );
print $res['cpanelresult']['data']['result'];
$cpanel->end();
